//+------------------------------------------------------------------+
//|                                                           BS.mq4 |
//|                      Copyright  2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern double MAPeriod=12;
extern double Lm = 0.23;
extern double Lb = 0.77;

double ExtMapBuffer1[];
double ExtMapBuffer2[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
  {
//---- indicators
    SetIndexBuffer(0, ExtMapBuffer1); SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 233);
    SetIndexBuffer(1, ExtMapBuffer2); SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 234);
    SetIndexLabel(0, "Up");
    SetIndexLabel(1, "Dn"); 
    return(0);
}
int deinit()
{
    return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

    for(int i = limit; i >=0; i--)
      {
         double Laguerre    = iCustom(NULL, 0, "Laguerre", 0, i);
         double Alpha       = iCCI(NULL, 0, 14, PRICE_CLOSE, i);
         double MA          = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_MEDIAN,i);
         double MAprevious  = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_MEDIAN,i+1);

         ExtMapBuffer1[i] = EMPTY_VALUE;
         ExtMapBuffer2[i] = EMPTY_VALUE;
            if((Laguerre<Lm) && (MA>MAprevious) && (Alpha<-5)) ExtMapBuffer1[i] = Low[i]  - 1.5*Point;
            if((Laguerre>Lb) && (MA<MAprevious) && (Alpha> 5)) ExtMapBuffer2[i] = High[i] + 1.5*Point;
      }
      return(0);
}


